#include-once

#cs######################
#   Accelerator table   #
#ce######################

Func CreateAcceleratorTable()
	Local $i = 0, $n = 0

	; --- Miscellaneous keys ---

	$i = 1
	Local $kbdTab = GUICtrlCreateDummy()			; Tab
	ReDim $aAccelKeys[$n+$i][2]
	$aAccelKeys[$n+$i-1][0] = "{TAB}"
	$aAccelKeys[$n+$i-1][1] = $kbdTab
	GUICtrlSetOnEvent( $kbdTab, "kbdTab" )
	$n += $i

	$i = 1
	Local $kbdEnter = GUICtrlCreateDummy()		; Enter
	ReDim $aAccelKeys[$n+$i][2]
	$aAccelKeys[$n+$i-1][0] = "{ENTER}"
	$aAccelKeys[$n+$i-1][1] = $kbdEnter
	GUICtrlSetOnEvent( $kbdEnter, "kbdEnter" )
	$n += $i

	; --- Keys to rotate the cube ---

	$i = 1
	Local $kbdHome = GUICtrlCreateDummy()			; Home
	ReDim $aAccelKeys[$n+$i][2]
	$aAccelKeys[$n+$i-1][0] = "{HOME}"
	$aAccelKeys[$n+$i-1][1] = $kbdHome
	GUICtrlSetOnEvent( $kbdHome, "kbdHome" )
	$n += $i

	$i = 2
	Local $kbdH = GUICtrlCreateDummy()				; H,h => Home
	ReDim $aAccelKeys[$n+$i][2]
	$aAccelKeys[$n+$i-2][0] = "H"
	$aAccelKeys[$n+$i-2][1] = $kbdH
	$aAccelKeys[$n+$i-1][0] = "h"
	$aAccelKeys[$n+$i-1][1] = $kbdH
	GUICtrlSetOnEvent( $kbdH, "kbdH" )
	$n += $i

	$i = 1
	Local $kbdLeft = GUICtrlCreateDummy()			; Left
	ReDim $aAccelKeys[$n+$i][2]
	$aAccelKeys[$n+$i-1][0] = "{LEFT}"
	$aAccelKeys[$n+$i-1][1] = $kbdLeft
	GUICtrlSetOnEvent( $kbdLeft, "kbdLeft" )
	$n += $i

	$i = 2
	Local $kbdA = GUICtrlCreateDummy()				; A,a => Left
	ReDim $aAccelKeys[$n+$i][2]
	$aAccelKeys[$n+$i-2][0] = "A"
	$aAccelKeys[$n+$i-2][1] = $kbdA
	$aAccelKeys[$n+$i-1][0] = "a"
	$aAccelKeys[$n+$i-1][1] = $kbdA
	GUICtrlSetOnEvent( $kbdA, "kbdA" )
	$n += $i

	$i = 1
	Local $kbdRight = GUICtrlCreateDummy()		; Right
	ReDim $aAccelKeys[$n+$i][2]
	$aAccelKeys[$n+$i-1][0] = "{RIGHT}"
	$aAccelKeys[$n+$i-1][1] = $kbdRight
	GUICtrlSetOnEvent( $kbdRight, "kbdRight" )
	$n += $i

	$i = 2
	Local $kbdS = GUICtrlCreateDummy()				; S,s => Right
	ReDim $aAccelKeys[$n+$i][2]
	$aAccelKeys[$n+$i-2][0] = "S"
	$aAccelKeys[$n+$i-2][1] = $kbdS
	$aAccelKeys[$n+$i-1][0] = "s"
	$aAccelKeys[$n+$i-1][1] = $kbdS
	GUICtrlSetOnEvent( $kbdS, "kbdS" )
	$n += $i

	$i = 3
	Local $kbdUp = GUICtrlCreateDummy()				; Up
	ReDim $aAccelKeys[$n+$i][2]
	$aAccelKeys[$n+$i-3][0] = "{UP}"
	$aAccelKeys[$n+$i-3][1] = $kbdUp
	$aAccelKeys[$n+$i-2][0] = "W"							; w,w => Up
	$aAccelKeys[$n+$i-2][1] = $kbdUp
	$aAccelKeys[$n+$i-1][0] = "w"
	$aAccelKeys[$n+$i-1][1] = $kbdUp
	GUICtrlSetOnEvent( $kbdUp, "kbdUp" )
	$n += $i

	$i = 3
	Local $kbdDown = GUICtrlCreateDummy()			; Down
	ReDim $aAccelKeys[$n+$i][2]
	$aAccelKeys[$n+$i-3][0] = "{DOWN}"
	$aAccelKeys[$n+$i-3][1] = $kbdDown
	$aAccelKeys[$n+$i-2][0] = "Z"							; w,w => Up
	$aAccelKeys[$n+$i-2][1] = $kbdDown
	$aAccelKeys[$n+$i-1][0] = "z"
	$aAccelKeys[$n+$i-1][1] = $kbdDown
	GUICtrlSetOnEvent( $kbdDown, "kbdDown" )
	$n += $i

	; --- Numeric keys 1-6 or keys 1-6 ---

	$i = 2
	Local $kbdNum1 = GUICtrlCreateDummy()			; Num 1, 1
	ReDim $aAccelKeys[$n+$i][2]
	$aAccelKeys[$n+$i-2][0] = "{NUMPAD1}"
	$aAccelKeys[$n+$i-2][1] = $kbdNum1
	$aAccelKeys[$n+$i-1][0] = "1"
	$aAccelKeys[$n+$i-1][1] = $kbdNum1
	GUICtrlSetOnEvent( $kbdNum1, "kbdNum1" )
	$n += $i

	$i = 2
	Local $kbdNum2 = GUICtrlCreateDummy()			; Num 2, 2
	ReDim $aAccelKeys[$n+$i][2]
	$aAccelKeys[$n+$i-2][0] = "{NUMPAD2}"
	$aAccelKeys[$n+$i-2][1] = $kbdNum2
	$aAccelKeys[$n+$i-1][0] = "2"
	$aAccelKeys[$n+$i-1][1] = $kbdNum2
	GUICtrlSetOnEvent( $kbdNum2, "kbdNum2" )
	$n += $i

	$i = 2
	Local $kbdNum3 = GUICtrlCreateDummy()			; Num 3, 3
	ReDim $aAccelKeys[$n+$i][2]
	$aAccelKeys[$n+$i-2][0] = "{NUMPAD3}"
	$aAccelKeys[$n+$i-2][1] = $kbdNum3
	$aAccelKeys[$n+$i-1][0] = "3"
	$aAccelKeys[$n+$i-1][1] = $kbdNum3
	GUICtrlSetOnEvent( $kbdNum3, "kbdNum3" )
	$n += $i

	$i = 2
	Local $kbdNum4 = GUICtrlCreateDummy()			; Num 4, 4
	ReDim $aAccelKeys[$n+$i][2]
	$aAccelKeys[$n+$i-2][0] = "{NUMPAD4}"
	$aAccelKeys[$n+$i-2][1] = $kbdNum4
	$aAccelKeys[$n+$i-1][0] = "4"
	$aAccelKeys[$n+$i-1][1] = $kbdNum4
	GUICtrlSetOnEvent( $kbdNum4, "kbdNum4" )
	$n += $i

	$i = 2
	Local $kbdNum5 = GUICtrlCreateDummy()			; Num 5, 5
	ReDim $aAccelKeys[$n+$i][2]
	$aAccelKeys[$n+$i-2][0] = "{NUMPAD5}"
	$aAccelKeys[$n+$i-2][1] = $kbdNum5
	$aAccelKeys[$n+$i-1][0] = "5"
	$aAccelKeys[$n+$i-1][1] = $kbdNum5
	GUICtrlSetOnEvent( $kbdNum5, "kbdNum5" )
	$n += $i

	$i = 2
	Local $kbdNum6 = GUICtrlCreateDummy()			; Num 6, 6
	ReDim $aAccelKeys[$n+$i][2]
	$aAccelKeys[$n+$i-2][0] = "{NUMPAD6}"
	$aAccelKeys[$n+$i-2][1] = $kbdNum6
	$aAccelKeys[$n+$i-1][0] = "6"
	$aAccelKeys[$n+$i-1][1] = $kbdNum6
	GUICtrlSetOnEvent( $kbdNum6, "kbdNum6" )
	$n += $i

	; --- Keys to zoom in/out ---

	$i = 3
	Local $kbdPageUp = GUICtrlCreateDummy()		; Page Up
	ReDim $aAccelKeys[$n+$i][2]
	$aAccelKeys[$n+$i-3][0] = "{PGUP}"
	$aAccelKeys[$n+$i-3][1] = $kbdPageUp
	$aAccelKeys[$n+$i-2][0] = "I"							; I,i => Page Up
	$aAccelKeys[$n+$i-2][1] = $kbdPageUp
	$aAccelKeys[$n+$i-1][0] = "i"
	$aAccelKeys[$n+$i-1][1] = $kbdPageUp
	GUICtrlSetOnEvent( $kbdPageUp, "kbdPageUp" )
	$n += $i

	$i = 3
	Local $kbdPageDown = GUICtrlCreateDummy()	; Page Down
	ReDim $aAccelKeys[$n+$i][2]
	$aAccelKeys[$n+$i-3][0] = "{PGDN}"
	$aAccelKeys[$n+$i-3][1] = $kbdPageDown
	$aAccelKeys[$n+$i-2][0] = "O"							; O,o => Page Down
	$aAccelKeys[$n+$i-2][1] = $kbdPageDown
	$aAccelKeys[$n+$i-1][0] = "o"
	$aAccelKeys[$n+$i-1][1] = $kbdPageDown
	GUICtrlSetOnEvent( $kbdPageDown, "kbdPageDown" )
	$n += $i

	GUISetAccelerators( $aAccelKeys, $hGui )
EndFunc


#cs####################
#   Keyboard events   #
#ce####################

; --- Miscellaneous keys ---

Func kbdTab()
	KeyboardHandler( $VK_TAB )
EndFunc

Func kbdEnter()
	KeyboardHandler( $VK_RETURN )
EndFunc

Func KeyboardHandler( $vKey )
	If GuiCtrlGetFocus( $hScramble ) <> $srmInput Then _
		Return

	Switch $vKey
		Case $VK_TAB
			ControlFocus( $hScramble, "", $srmNew )

		Case $VK_RETURN
			srmInput()
	EndSwitch
EndFunc

; --- Keys to rotate the cube ---

Func kbdHome()
	KeyboardHandlerRotate( $VK_HOME )
EndFunc

Func kbdH()			; H,h => Home
	KeyboardHandlerRotate( $VK_H )
EndFunc

Func kbdLeft()
	KeyboardHandlerRotate( $VK_LEFT )
EndFunc

Func kbdA()			; A,a => Left
	KeyboardHandlerRotate( $VK_A )
EndFunc

Func kbdRight()
	KeyboardHandlerRotate( $VK_RIGHT )
EndFunc

Func kbdS()			; S,s => Right
	KeyboardHandlerRotate( $VK_S )
EndFunc

Func kbdUp()		; W,w => Up
	KeyboardHandlerRotate( $VK_UP )
EndFunc

Func kbdDown()	; Z,z => Down
	KeyboardHandlerRotate( $VK_DOWN )
EndFunc

Func KeyboardHandlerRotate( $vKey )
	If $fRotate Then Return

	Local $fKey = False

	Switch $vKey
		Case $VK_HOME, $VK_LEFT, $VK_RIGHT
			If GuiCtrlGetFocus( $hScramble ) = $srmInput Then
				GUISetAccelerators( "", $hGui )
				$fKey = True
			EndIf
	EndSwitch

	Switch $vKey
		Case $VK_HOME, $VK_H		; H,h => Home
			If $fKey Then
				ControlSend( $hScramble, "", $srmInput, "{HOME}" )
			Else
				RotateHome()
			EndIf

		Case $VK_LEFT, $VK_A		; A,a => Left
			If $fKey Then
				ControlSend( $hScramble, "", $srmInput, "{LEFT}" )
			Else
				RotateLeft()
			EndIf

		Case $VK_RIGHT, $VK_S		; S,s => Right
			If $fKey Then
				ControlSend( $hScramble, "", $srmInput, "{RIGHT}" )
			Else
				RotateRight()
			EndIf

		Case $VK_UP							; W,w => Up
			RotateUp()

		Case $VK_DOWN						; Z,z => Down
			RotateDown()
	EndSwitch

	If $fKey Then _
		GUISetAccelerators( $aAccelKeys, $hGui )
EndFunc

; --- Numeric keys 1-6 or keys 1-6 ---

Func kbdNum1()
	KeyboardHandlerNumKeys( $VK_NUMPAD1 )
EndFunc

Func kbdNum2()
	KeyboardHandlerNumKeys( $VK_NUMPAD2 )
EndFunc

Func kbdNum3()
	KeyboardHandlerNumKeys( $VK_NUMPAD3 )
EndFunc

Func kbdNum4()
	KeyboardHandlerNumKeys( $VK_NUMPAD4 )
EndFunc

Func kbdNum5()
	KeyboardHandlerNumKeys( $VK_NUMPAD5 )
EndFunc

Func kbdNum6()
	KeyboardHandlerNumKeys( $VK_NUMPAD6 )
EndFunc

Func KeyboardHandlerNumKeys( $vKey )
	Local $fKey = False

	If GuiCtrlGetFocus( $hScramble ) = $srmInput Then
		GUISetAccelerators( "", $hGui )
		$fKey = True
	EndIf

	Switch $vKey
		Case $VK_NUMPAD1
			If $fKey Then
				ControlSend( $hScramble, "", $srmInput, "1" )
			Else
				SideRight()
			EndIf

		Case $VK_NUMPAD2
			If $fKey Then
				ControlSend( $hScramble, "", $srmInput, "2" )
			Else
				SideLeft()
			EndIf

		Case $VK_NUMPAD3
			If $fKey Then
				ControlSend( $hScramble, "", $srmInput, "3" )
			Else
				SideTop()
			EndIf

		Case $VK_NUMPAD4
			If $fKey Then
				ControlSend( $hScramble, "", $srmInput, "4" )
			Else
				SideBottom()
			EndIf

		Case $VK_NUMPAD5
			If $fKey Then
				ControlSend( $hScramble, "", $srmInput, "5" )
			Else
				SideFront()
			EndIf

		Case $VK_NUMPAD6
			If $fKey Then
				ControlSend( $hScramble, "", $srmInput, "6" )
			Else
				SideBack()
			EndIf
	EndSwitch

	If $fKey Then _
		GUISetAccelerators( $aAccelKeys, $hGui )
EndFunc

; --- Keys to zoom in/out ---

Func kbdPageUp()
	KeyboardHandlerZoom( $VK_PRIOR )
EndFunc

Func kbdPageDown()
	KeyboardHandlerZoom( $VK_NEXT )
EndFunc

Func KeyboardHandlerZoom( $vKey )
	Switch $vKey
		; Zoom in
		Case $VK_PRIOR	; I,i => Page Up
			ZoomIn()

		; Zoom out
		Case $VK_NEXT		; O,o => Page Down
			ZoomOut()
	EndSwitch
EndFunc

; --- Functions ---

Func GuiCtrlGetFocus( $hGui = "" )
	Local $idCtrl = ControlGetHandle( $hGui, "", ControlGetFocus( $hGui ) )
	Return ControlGetGuiId( $idCtrl )
EndFunc

Func ControlGetGuiId( $idCtrl )
	Local $aRet = DllCall( $dllUser32, "int", "GetDlgCtrlID", "hwnd", $idCtrl )
	If @error = 0 Then Return $aRet[0]
	Return SetError( 1, 0, "" )
EndFunc
