; See http://www.autoitscript.com/forum/index.php?showtopic=83581 by trancexx

#include-once

; Version
Global Const $GL_VERSION_1_1 = 1

; PixelFormatDescriptor
Global Const $PFD_TYPE_RGBA = 0
Global Const $PFD_MAIN_PLANE = 0
Global Const $PFD_DOUBLEBUFFER = 1
Global Const $PFD_DRAW_TO_WINDOW = 4
Global Const $PFD_SUPPORT_OPENGL = 32

; AttribMask
Global Const $GL_DEPTH_BUFFER_BIT = 0x00000100
Global Const $GL_COLOR_BUFFER_BIT = 0x00004000

; BeginMode
Global Const $GL_POINTS = 0x0000
Global Const $GL_LINES = 0x0001
Global Const $GL_LINE_LOOP = 0x0002
Global Const $GL_LINE_STRIP = 0x0003
Global Const $GL_TRIANGLES = 0x0004
Global Const $GL_TRIANGLE_STRIP = 0x0005
Global Const $GL_TRIANGLE_FAN = 0x0006
Global Const $GL_QUADS = 0x0007
Global Const $GL_QUAD_STRIP = 0x0008
Global Const $GL_POLYGON = 0x0009

; GetTarget
Global Const $GL_DEPTH_TEST = 0x0B71
Global Const $GL_VIEWPORT = 0x0BA2
Global Const $GL_MODELVIEW_MATRIX = 0x0BA6
Global Const $GL_PROJECTION_MATRIX = 0x0BA7

; ListMode
Global Const $GL_COMPILE = 0x1300

; MatrixMode
Global Const $GL_MODELVIEW = 0x1700
Global Const $GL_PROJECTION = 0x1701

; ShadingModel
Global Const $GL_FLAT = 0x1D00
Global Const $GL_SMOOTH = 0x1D01

; pi
Global Const $PI = 3.14159265358979323846

; Matrices

; --- A note about OpenGL matrices ---

; OpenGL accesses matrices in column major order, i.e. the matrix elements have the following indices:

;		 0  4  8  12
;		 1  5  9  13
;		 2  6 10  14
;		 3  7 11  15

; In AutoIt/C/C++ multidimensional arrays the row and column indices are transposed like this:

;		 0  1  2  3
;		 4  5  6  7
;		 8  9 10 11
;		12 13 14 15

; ------------------------------------

Global Const $NULL_MATRIX[16] = [ _
	0, 0, 0, 0, _
	0, 0, 0, 0, _
	0, 0, 0, 0, _
	0, 0, 0, 0 ]

Global Const $IDENTITY_MATRIX[16] = [ _
	1, 0, 0, 0, _
	0, 1, 0, 0, _
	0, 0, 1, 0, _
	0, 0, 0, 1 ]
